/* --8<--8<--8<--8<--
 *
 * Copyright (C) 2006 Smithsonian Astrophysical Observatory
 *
 * This file is part of mst_rdb
 *
 * mst_rdb is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * mst_rdb is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the 
 *       Free Software Foundation, Inc. 
 *       51 Franklin Street, Fifth Floor
 *       Boston, MA  02110-1301, USA
 *
 * -->8-->8-->8-->8-- */

/* rdb_rewind.c */

#include "mst_rdb.h"

#include <stdlib.h>
#include <stdio.h>
#include <ctype.h>
#include <errno.h>
#include <string.h>

#include <tracefct/tracefct.h>
#include <tracefct/exiterrvals.h>

/* hack for non-posix-ness of SunOS4 */
#ifndef SEEK_SET
#define SEEK_SET 0
#endif
/*

  PROCEDURE
    rdb_rewind - rewind database to first data row

  DESCRIPTION
    rdb_rewind repositions the database such that the next
    read will return the first row in the database.

  RETURNS
    Upon success it returns 0. If the file cannot be rewound,
    it returns 1. Upon error it returns -1.

  AUTHOR
    Diab Jerius

*/
int
rdb_rewind(
  FILE *fin,			/* the stream to parse */
  rdbHeader *hdr		/* the rdb file description */
)
{
  if ( hdr->can_rewind )
  {
    if( fseek( fin, hdr->start, SEEK_SET) )
      return -1;
  }
  else
    return 1;

  return 0;
}    
